;################################################################################
;#										#
;# chipbasic - single chip basic computer with ATMega 16			#
;# menu functions								#
;# copyright (c) 2006/7 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 2		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

.equ	menu_max = 7
;------------------------------------------------------------------------------
;main screen mask
;------------------------------------------------------------------------------
menu_main:	ldi	XL,1
		libmio_chpump			;enable chargepump for serial
		sts	libmio_channel,byte0	;output to screen
		rcall	menu_maxbox
		ldi	YL,0
		ldi	YH,40
		ldi	ZL,59
		ldi	ZH,40
		libmio_fbox
		clr	ereg		
		clr	ctrl
		libmio_thistext
		.db 2,3,"AVR CHIPBASIC-M16 V0.72",0
		libmio_thistext
		.db 3,2,"(C) 2006/7  JOERG WOLFRAM",0

		libmio_thistext
		.db	6,4,"EDITOR",0

		libmio_thistext
		.db	8,4,"RUN",0

		libmio_thistext			;load from card
		.db	10,4,0
		rcall	menu_text1

		libmio_thistext			;save to card
		.db	12,4,0
		rcall	menu_text2

		libmio_thistext			;load from serial
		.db	14,4,0
		rcall	menu_text3

		libmio_thistext			;save to serial
		.db	16,4,0
		rcall	menu_text4

		libmio_thistext			;save to serial
		.db	18,4,0
		rcall	menu_text5

		
		libmio_thistext			;show program name
		.db	21,1,0
		rcall	menu_outname


		ldi	ZL,0			;pos 1
menu_main_1:	ldi	YL,LOW(libmio_vram+6*libmio_cols+3)
		ldi	YH,HIGH(libmio_vram+6*libmio_cols+3)
		ldi	ZH,0
menu_main_2:	ldi	XL,0x20
		cp	ZH,ZL
		brne	menu_main_3
		ldi	XL,0x16
menu_main_3:	st	Y,XL
		adiw	YL,libmio_cols*2
		inc	ZH
		cpi	ZH,menu_max
		brne	menu_main_2
		
menu_main_4:	libmio_waitkey

;------------------------------------------------------------------------------
;cursor up key
;------------------------------------------------------------------------------
menu_main_4n:	cpi	tempreg1,0xe4		;up
		brne	menu_main_5
		dec	ZL
		cpi	ZL,0xff
		brne	menu_main_1
		ldi	ZL,0x00
		rjmp	menu_main_1

;------------------------------------------------------------------------------
;cursor down key
;------------------------------------------------------------------------------
menu_main_5:	cpi	tempreg1,0xe5		;down
		brne	menu_main_6
		inc	ZL
		cpi	ZL,menu_max
		brne	menu_main_1
		ldi	ZL,menu_max-1
		rjmp	menu_main_1

;------------------------------------------------------------------------------
;enter key
;------------------------------------------------------------------------------
menu_main_6:	cpi	tempreg1,0xea		;enter
		brne	menu_main_1
		cpi	ZL,0x00			;EDIT
		brne	menu_main_7
		clr	ereg
		rjmp	menu_editloop
menu_main_7:	cpi	ZL,0x01			;RUN
		brne	menu_main_8
		sts	libmio_kflags,byte0
		rcall	menu_runprog		;run programm
		cpi	ereg,0x02
		brcc	menu_editloop
menu_main_71:	libmio_waitkey
		cpi	tempreg1,0xed		;ESC		
		brne	menu_main_71
		rjmp	menu_main
menu_main_8:	cpi	ZL,0x02			;load from module
		brne	menu_main_9
		rjmp	menu_mread
menu_main_9:	cpi	ZL,0x03			;save to module
		brne	menu_main_10
		rjmp	menu_mstore
menu_main_10:	cpi	ZL,0x04			;load from serial
		brne	menu_main_11
		rcall	menu_sread
		rjmp	menu_main
menu_main_11:	cpi	ZL,0x05			;save to serial
		brne	menu_main_12
		rjmp	menu_swrite
		
menu_main_12:	rjmp	menu_print		
;------------------------------------------------------------------------------
; editor loop
;------------------------------------------------------------------------------
menu_editloop:	ldi	XL,7
		sts	libmio_color,XL		;plot color = white
		lds	XL,libmio_keycode
		cpi	XL,0
		brne	menu_editloop
		call	editor_main
		sts	libmio_kflags,byte0
		lds	XL,libmio_lastkey
		cpi	XL,0xfa			;F10
		breq	menu_editloop1
		rjmp	menu_main
menu_editloop1:	call	menu_runprog		;run programm
menu_editloop2:	libmio_waitkey
		cpi	tempreg1,0xed		;ESC
		brne	menu_editloop2
		rjmp	menu_editloop

;------------------------------------------------------------------------------
; read from module
;------------------------------------------------------------------------------
menu_mread:	rcall	menu_maxbox
		libmio_thistext
		.db	2,4,0
		rcall	menu_text1
		rcall	menu_flist
		rcall	menu_msel
		cpi	XL,0xff
		brne	menu_mread02
		rjmp	menu_main
menu_mread02:	rcall	i2c_rprog
		cpi	ereg,0
		brne	menu_moderr
		rjmp	menu_main		
		
;------------------------------------------------------------------------------
; store to module
;------------------------------------------------------------------------------
menu_mstore:	rcall	menu_maxbox
		libmio_thistext
		.db	2,4,0
		rcall	menu_text6
		rcall	menu_flist
		rcall	menu_msel
		cpi	XL,0xff
		brne	menu_mstore02
		rjmp	menu_main
menu_mstore02:	rcall	i2c_wprog
		cpi	ereg,0
		brne	menu_moderr
		rjmp	menu_main		


menu_moderr:	libmio_thistext
		.db	21,1,"MEMORY CARD ERROR",0
		libmio_waitkey
		rjmp	menu_main

;------------------------------------------------------------------------------
; show filelist
;------------------------------------------------------------------------------
menu_flist:	clr	XL			;first program number
menu_flist1:	ldi	YL,LOW(libmio_vram+5*libmio_cols+6)		
		ldi	YH,HIGH(libmio_vram+5*libmio_cols+6)		
		ldi	XH,libmio_cols
		mul	XH,XL
		add	YL,r0
		adc	YH,r1
		push	XL
		rcall	i2c_rname
		pop	XL
		cpi	ereg,0
		breq	menu_flist2
		pop	XL
		pop	XL
		rjmp	menu_moderr	
menu_flist2:	inc	XL
		cpi	XL,0x10
		brne	menu_flist1
		ret

;------------------------------------------------------------------------------
; read from serial
;------------------------------------------------------------------------------
menu_sread:	libmio_clrscr
		libmio_thistext			;show program name
		.db	0,0,"RECEIVING...",0
		clr	ctrl			;start with line 0
		ldi	ZL,LOW(libmio_vram+libmio_cols)
		ldi	ZH,HIGH(libmio_vram+libmio_cols)
		mov	r14,ZL
		mov	r15,ZH	
		ldi	tempreg2,libmio_cols	;max chars
		ldi	tempreg1,0x11		;XON
		libmio_pser			;send
		
menu_sread1:	ldi	tempreg2,libmio_cols
		mov	ZL,r14
		mov	ZH,r15
		adiw	ZL,libmio_cols
		mov	r14,ZL
		mov	r15,ZH	
menu_sreadv:	libmio_gser
		cpi	tempreg1,0x20		;ignore all less than space
		brcs	menu_sreadv
		cpi	tempreg1,'#'		;end
		breq	menu_sread5		
		rjmp	menu_sread2a
menu_sread2:	libmio_gser			;get serial
		cpi	tempreg1,0x20		;space
		brcs	menu_sread3		;is less -> control
		cpi	tempreg1,'a'
		brcs	menu_sread2a
		cpi	tempreg1,'z'+1
		brcc	menu_sread2a
		subi	tempreg1,'a'-'A'
		
menu_sread2a:	st	Z+,tempreg1
		dec	tempreg2
		brne	menu_sread2		;OK

menu_sread4:	libmio_gser
		cpi	tempreg1,0x1f		;ignore all characters
		brcc	menu_sread4						    
	
menu_sread3:	inc	ctrl
		cpi	ctrl,bas_lines+1
		brne	menu_sread1						    


menu_sread5:	libmio_thistext			;show program name
		.db	0,0,"COMPRESSING...",0
		ldi	ZL,LOW(libmio_vram+2*libmio_cols+9)
		ldi	ZH,HIGH(libmio_vram+2*libmio_cols+9)
		call	ee_writename
		jmp	lce_psave

;------------------------------------------------------------------------------
; write to serial
;------------------------------------------------------------------------------
menu_swrite:	libmio_thistext			;show program name
		.db	21,1,"SENDING PROGRAM...     ",0
		ldi	XL,0x01			;serial
		sts	libmio_channel,XL	;set channel
		rcall	menu_outname
		call	lce_findlast		;list program
		ldi	tempreg1,'#'		;stopper
		libmio_outchar
		ldi	tempreg1,0x0d		;carriage return
		libmio_outchar
		ldi	tempreg1,0x0a		;line feed
		libmio_outchar
		rjmp	menu_main		;back to main loop

;------------------------------------------------------------------------------
; print program
;------------------------------------------------------------------------------
menu_print:	libmio_thistext			;show program name
		.db	21,1,"PRINTING...            ",0
		ldi	XL,0x02			;printer
		sts	libmio_channel,XL	;set channel
		libmio_newline
		libmio_newline
		rcall	menu_outname
		libmio_newline
		call	lce_findlast		;list program
		ldi	tempreg1,0x0c		;form feed
		libmio_outchar
		rjmp	menu_main		;back to main loop

;------------------------------------------------------------------------------
; output program name
;------------------------------------------------------------------------------
menu_outname:	libmio_thistext
		.db	255,"PROGRAM: ",0
		ldi	ZL,LOW(bas_inbuf)
		ldi	ZH,HIGH(bas_inbuf)
		call	ee_readname
		st	Z+,byte0
		ldi	ZL,LOW(bas_inbuf)
		ldi	ZH,HIGH(bas_inbuf)
		libmio_ramtext		
		libmio_newline
		ret

;------------------------------------------------------------------------------
; select a program from list
;------------------------------------------------------------------------------
menu_msel:	ldi	ZL,0			;pos 1
menu_msel_1:	ldi	YL,LOW(libmio_vram+5*libmio_cols+5)
		ldi	YH,HIGH(libmio_vram+5*libmio_cols+5)
		ldi	ZH,0
menu_msel_2:	ldi	XL,0x20
		cp	ZH,ZL
		brne	menu_msel_3
		ldi	XL,0x16
menu_msel_3:	st	Y,XL
		adiw	YL,libmio_cols
		inc	ZH
		cpi	ZH,16
		brne	menu_msel_2
		
menu_msel_4:	libmio_waitkey			;wait for keypress

;------------------------------------------------------------------------------
;cursor up key
;------------------------------------------------------------------------------
		cpi	tempreg1,0xe4		;up
		brne	menu_msel_5
		dec	ZL
		cpi	ZL,0xff
		brne	menu_msel_1
		ldi	ZL,0x00
		rjmp	menu_msel_1

;------------------------------------------------------------------------------
;cursor down key
;------------------------------------------------------------------------------
menu_msel_5:	cpi	tempreg1,0xe5		;down
		brne	menu_msel_6
		inc	ZL
		cpi	ZL,16
		brne	menu_msel_1
		ldi	ZL,15
		rjmp	menu_msel_1

;------------------------------------------------------------------------------
;enter key
;------------------------------------------------------------------------------
menu_msel_6:	cpi	tempreg1,0xea		;enter
		brne	menu_msel_7
		mov	XL,ZL
		ret

;------------------------------------------------------------------------------
;escape key
;------------------------------------------------------------------------------
menu_msel_7:	cpi	tempreg1,0xed		;esc
		brne	menu_msel_1
		ldi	XL,0xff
		ret		
		

;------------------------------------------------------------------------------
;text load from memory card
;------------------------------------------------------------------------------
menu_text1:	libmio_thistext
		.db	255,"LOAD FROM MEMORY CARD",0
		ret

;------------------------------------------------------------------------------
;text save to memory card
;------------------------------------------------------------------------------
menu_text2:	libmio_thistext
		.db	255,"SAVE TO MEMORY CARD",0
		ret	

;------------------------------------------------------------------------------
;text save to memory card
;------------------------------------------------------------------------------
menu_text6:	libmio_thistext
		.db	255,"SAVE ",0
		libmio_calc
		mov	ZL,YL
		mov	ZH,YH
		jmp	ee_readname

;------------------------------------------------------------------------------
;text load from serial
;------------------------------------------------------------------------------
menu_text3:	libmio_thistext
		.db	255,"RECEIVE FILE",0
		ret

;------------------------------------------------------------------------------
;text save to serial
;------------------------------------------------------------------------------
menu_text4:	libmio_thistext
		.db	255,"SEND FILE",0
		ret

;------------------------------------------------------------------------------
;text print listing
;------------------------------------------------------------------------------
menu_text5:	libmio_thistext
		.db	255,"PRINT LISTING",0
		ret
		
;------------------------------------------------------------------------------
;run program
;------------------------------------------------------------------------------
menu_runprog:	libmio_clrscr			;clear screen from menu			
		call	tbrun			;run programm
		lds	XL,libmio_config	;SLOW
		andi	XL,0x3f
		sts	libmio_config,XL
		sts	libmio_channel,byte0	;set output to screen
		libmio_newline
		libmio_thistext
		.db libmio_rows-1,0,16,0x17,0x18,0x19,0x1a,0x1a,0x10,0x19,0x1a,0x1b,0x10,0
		ret	

;------------------------------------------------------------------------------
;clear screen and draw box
;------------------------------------------------------------------------------
menu_maxbox:	libmio_clrscr			;clear screen
		ldi	YL,5
		sts	libmio_color,YL
		ldi	YL,0
		ldi	YH,0
		ldi	ZL,59
		ldi	ZH,45
		libmio_box		
		ret
		
		